<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="historySettleId"
          :columns="columns"
          :datasource="datasource"
          v-model:selection="selection"
          tool-class="ele-toolbar-form"
          :scroll="{ x: 800 }"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <Edit v-model:visible="showEdit" :data="current" @done="reload" />
      <!-- 合同详情弹窗 -->
      <Info v-model:visible="showInfo" :data="current" @done="reload" />
      <!-- 批量转移弹窗 -->
      <!--    <CustomerMove v-model:visible="showMove" :data="selection" @done="batchMove" />-->
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ExclamationCircleOutlined,
    UserOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import Edit from './components/edit.vue';
  import Info from './components/info.vue';
  import { timeAgo } from 'ele-admin-pro';
  import { useUserStore } from '@/store/modules/user';
  import { pageHistorySettle, removeBatchHistorySettle, removeHistorySettle } from "@/api/tower/historySettle";
  import { HistorySettle, HistorySettleParam } from "@/api/tower/historySettle/model";

  const userStore = useUserStore();
  // 当前用户信息
  const loginUser = computed(() => userStore.info ?? {});

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<HistorySettle[]>([]);
  // 当前编辑数据
  const current = ref<HistorySettle | null>(null);

  // 是否显示资产详情
  const showInfo = ref(false);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageHistorySettle({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '项目名称',
      dataIndex: 'projectName',
      key: 'projectName',
    },
    {
      title: '合同编号',
      dataIndex: 'contractNo'
    },
    {
      title: '设备名称',
      dataIndex: 'equipmentName',
    },
    {
      title: '设备型号',
      dataIndex: 'equipmentModel'
    },
    {
      title: '出厂编号',
      dataIndex: 'factoryNo',
    },
    {
      title: '备案编号',
      dataIndex: 'filingNo'
    },
    {
      title: '自编号',
      dataIndex: 'equipmentNo'
    },
    {
      title: '设备结算租金含税金额',
      dataIndex: 'amountWithTax'
    },
    {
      title: '设备结算租金税率',
      dataIndex: 'taxAmount'
    },
    {
      title: '进出场费含税金额',
      dataIndex: 'inOutWithTax'
    },
    {
      title: '进出场费税率',
      dataIndex: 'inOutTax'
    },
    {
      title: '劳务费含税金额',
      dataIndex: 'workerAmountWithTax'
    },
    {
      title: '劳务费税率',
      dataIndex: 'workerTax'
    },
    {
      title: '其他费用含税金额',
      dataIndex: 'otherAmountWithTax'
    },
    {
      title: '其他费用税率',
      dataIndex: 'otherTax'
    },
    {
      title: '开始日期',
      dataIndex: 'startDate'
    },
    {
      title: '结束日期',
      dataIndex: 'endDate'
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: HistorySettleParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: HistorySettle) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const showSettle = ref<Boolean>(false)
  const openSettle = (row?: HistorySettle) => {
    current.value = row ?? null;
    showSettle.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 打开用户详情弹窗 */
  const openInfo = (row?: HistorySettle) => {
    current.value = row ?? null;
    showInfo.value = true;
  };

  /* 删除单个 */
  const remove = (row: HistorySettle) => {
    const hide = message.loading('请求中..', 0);
    removeHistorySettle(row.historySettleId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量转移 */
  const batchMove = (userId) => {
    console.log(userId, '批量转移0000');
    console.log(selection.value);
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchHistorySettle(
          selection.value.map((d) => {
            if (loginUser.value.userId === d.userId) {
              return d.historySettleId;
            }
          })
        )
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>

<script lang="ts">
  export default {
    name: 'Accessory'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
